// CIJL.h: interface for the CIJL class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IJL_H__5FB98192_49BA_45AC_87A0_B7E70EBC691F__INCLUDED_)
#define AFX_IJL_H__5FB98192_49BA_45AC_87A0_B7E70EBC691F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CIJL  
{
protected:
	
	int los; // Length of one scan line
	LPBITMAPINFOHEADER m_lpHeader;
	LPBYTE m_lpData;
	
	bool LoadJpegFile(LPSTR lpszFileName);
	
public:
	CIJL();
	virtual ~CIJL();
	void DeleteBitInfo();
	
	// Load
	bool OpenJpegFile(LPSTR lpszFileName);
	bool LoadFromDIBBuf(BITMAPINFOHEADER * bmiHeader, BYTE *pDIB);
	bool LoadFromJpegBuf(BYTE* lpJpgBuffer,int nBufSize);
	// Save
	bool SaveToJpegFile(CString csFileName);
	static bool SaveToJpegFileFromDIBBuf(LPSTR strFileName,BITMAPINFOHEADER * bmiHeader, BYTE *pDIB);
	int SaveToJpegBuf(BYTE* &lpJpgBuffer,int jquality=100);
	
	// 
	bool DecodeOneHalfFromJpegBuf(BYTE* lpJpgBuffer,int nBufSize);
	void DoFlip();
	
	bool DrawJpeg(CDC *pDC, CRect *pDest, CRect *pSrc);
	
	bool GetImageSize(CSize *pSize);
	
	// Pixel
	void SetPixel(int x, int y, COLORREF col);
	COLORREF GetPixel(int x, int y);
	void SetRect(CRect *pRect, COLORREF *ColData);
	void GetRect(CRect *pRect, COLORREF *ColData);
	void SetFillRect(CRect *pRect, COLORREF col);
	
	bool IsValid()
	{
		if (!m_lpData)
			return false;
		if (!m_lpHeader) 
			return false;
		return true;
	}
};


#endif // !defined(AFX_IJL_H__5FB98192_49BA_45AC_87A0_B7E70EBC691F__INCLUDED_)
