// VideoChat.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VideoChat.h"
#include "VideoChatDlg.h"

#include "myuuids.h"
#include <qedit.h>
#include "CIJL.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////
//  Լ

// My App Object
CVideoChatApp * g_GetApp()
{
	return (CVideoChatApp*)AfxGetApp();
}

// My MainWnd Object
CVideoChatDlg * g_GetMainWnd()
{
	return (CVideoChatDlg*)AfxGetMainWnd();
}

//------------------------------------------------------------------------------
// Type Definitions
//------------------------------------------------------------------------------

typedef UINT (CALLBACK* PFNDLL_STES)(UINT);


// DIB header
#define DIB_HEADER_MARKER ((WORD)('M'<<8) | 'B')

/////////////////////////////////////////////////////////////////////////////
// CVideoChatApp

BEGIN_MESSAGE_MAP(CVideoChatApp, CWinApp)
	//{{AFX_MSG_MAP(CVideoChatApp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoChatApp construction

CVideoChatApp::CVideoChatApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CVideoChatApp object

CVideoChatApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CVideoChatApp initialization

BOOL CVideoChatApp::InitInstance()
{
	// α׷  ѹ ϱ!
	HANDLE hOnlyOne = CreateEvent(0,0,0,"VideoChat OnlyOne");
	if(hOnlyOne)
	{
		if(GetLastError() == ERROR_ALREADY_EXISTS) //=> ERROR_ALREADY_EXISTSܿ.
			return FALSE;
	}

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

    // Initialize COM
    if (FAILED(CoInitialize(NULL)))
    {
        TRACE(TEXT("CoInitialize Failed!\r\n")) ;
        exit(1) ;
    }

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CVideoChatDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

HRESULT CVideoChatApp::InitDirectShow()
{
    HRESULT hr ;

    m_hWnd = ((CVideoChatDlg*)AfxGetMainWnd())->m_hWnd;
	

	// ͱ׷Ŵ Ͽ ͱ׷  !
	if (m_pGB != NULL)
	{
		JIF(CleanDirectShow()) ;
	}

    // Clear open dialog remnants before calling RenderFile()
//    UpdateWindow(m_hWnd) ;

	// ͱ׷Ŵ  (  )
    // Get the interface for DirectShow's GraphBuilder
    JIF(CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void **)&m_pGB)) ;

	// Add a Filter ... Put a filter in the graph
	/*
	CComPtr<IBaseFilter> pFilterGenericWDMFilterProxy;
    LIF(CoCreateInstance(CLSID_L544_GenericWDMFilterProxy, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pFilterGenericWDMFilterProxy)) ;
	LIF(m_pGB->AddFilter(pFilterGenericWDMFilterProxy, L"Generic WDM Filter Proxy"));
	*/
	CComPtr<IBaseFilter> pFilterGenericWDMFilterProxy;
	LIF(FindFirstDevice(CLSID_VideoInputDeviceCategory, &pFilterGenericWDMFilterProxy))
	LIF(m_pGB->AddFilter(pFilterGenericWDMFilterProxy, L"Video Capture"));
   

	CComPtr<IBaseFilter> pFilterSmartTeeFilter;
    LIF(CoCreateInstance(CLSID_L544_SmartTeeFilter, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pFilterSmartTeeFilter)) ;
	LIF(m_pGB->AddFilter(pFilterSmartTeeFilter, L"Smart Tee Filter"));

	//CComPtr<IBaseFilter> pFilterSampleGrabber;
    //LIF(CoCreateInstance(CLSID_L544_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pFilterSampleGrabber)) ;
	//LIF(m_pGB->AddFilter(pFilterSampleGrabber, L"Sample Grabber"));
    LIF(CoCreateInstance(CLSID_L544_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&m_pSG)) ;
	LIF(m_pGB->AddFilter(m_pSG, L"SampleGrabber"));

	CComPtr<IBaseFilter> pFilterVideoRenderer;
    LIF(CoCreateInstance(CLSID_L544_VideoRenderer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pFilterVideoRenderer)) ;
	LIF(m_pGB->AddFilter(pFilterVideoRenderer, L"Video Renderer"));

	CComPtr<IBaseFilter> pFilterNullRenderer;
    LIF(CoCreateInstance(CLSID_L544_NullRenderer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pFilterNullRenderer)) ;
	LIF(m_pGB->AddFilter(pFilterNullRenderer, L"Null Renderer"));

	// Set Source Format
	CComPtr<IPin> pPin;
	LIF(pFilterGenericWDMFilterProxy->FindPin(L"0", &pPin));
	if (pPin != NULL)
	{
		CComQIPtr<IAMStreamConfig> pSC(pPin);
		if (pPin != NULL)
		{
			int iCount, iSize;
			hr = pSC->GetNumberOfCapabilities(&iCount, &iSize);

			for (int i=0; i<iCount; i++)
			{
				AM_MEDIA_TYPE *pmt;
				VIDEO_STREAM_CONFIG_CAPS scc;

				hr = pSC->GetStreamCaps(i, &pmt, (BYTE *)&scc);
				if (SUCCEEDED(hr))
				{
					if (pmt->subtype == /*MEDIASUBTYPE_IYUV*/ MEDIASUBTYPE_RGB24 && pmt->formattype == FORMAT_VideoInfo)
					{
						VIDEOINFO *pvi = (VIDEOINFO *)pmt->pbFormat;
						if (pvi->bmiHeader.biWidth == 176 
							&& pvi->bmiHeader.biHeight == 144)
						{
							LIF(pSC->SetFormat(pmt));
							i = iCount;	// we has to delete media type
						}
					}

					// delete media type
					if (pmt->cbFormat != 0) 
						CoTaskMemFree((PVOID)pmt->pbFormat);
					if (pmt->pUnk != NULL)
						pmt->pUnk->Release();
					CoTaskMemFree((PVOID)pmt);
				}
			}
		}
	}

	// Connect Filters ...
	//  , ҸŰ  CComPtr  ʴ´.
	IPin *pPinUp, *pPinDown;

	LIF(pFilterGenericWDMFilterProxy->FindPin(L"0", &pPinUp));
	LIF(pFilterSmartTeeFilter->FindPin(L"Input", &pPinDown));
	CONNECTPINS(m_pGB, pPinUp, pPinDown);
	SAFE_RELEASE(pPinUp);	// Release a interface
	SAFE_RELEASE(pPinDown);	// Release a interface


	LIF(pFilterSmartTeeFilter->FindPin(L"Preview", &pPinUp));
	LIF(pFilterVideoRenderer->FindPin(L"In", &pPinDown));
	CONNECTPINS(m_pGB, pPinUp, pPinDown);
	SAFE_RELEASE(pPinUp);	// Release a interface
	SAFE_RELEASE(pPinDown);	// Release a interface

	LIF(pFilterSmartTeeFilter->FindPin(L"Capture", &pPinUp));
	LIF(m_pSG->FindPin(L"In", &pPinDown));
	CONNECTPINS(m_pGB, pPinUp, pPinDown);
	SAFE_RELEASE(pPinUp);	// Release a interface
	SAFE_RELEASE(pPinDown);	// Release a interface

	LIF(m_pSG->FindPin(L"Out", &pPinUp));
	LIF(pFilterNullRenderer->FindPin(L"In", &pPinDown));
	CONNECTPINS(m_pGB, pPinUp, pPinDown);
	SAFE_RELEASE(pPinUp);	// Release a interface
	SAFE_RELEASE(pPinDown);	// Release a interface

	// ̵ Ÿ  ش.
	AM_MEDIA_TYPE mt;
	ZeroMemory(&mt, sizeof(mt));
//	mt.majortype = MEDIATYPE_Audio;
//	mt.subtype = MEDIASUBTYPE_PCM;
	mt.majortype = MEDIATYPE_Video;
	mt.subtype = MEDIASUBTYPE_RGB24;


	//CComQIPtr<ISampleGrabber> pSampleGrabber(m_pSG);
	CComQIPtr<ISampleGrabber> pSampleGrabber(m_pSG);
	if (pSampleGrabber != NULL)
	{
		LIF(pSampleGrabber->SetMediaType(&mt));
		LIF(pSampleGrabber->SetBufferSamples(TRUE));
	}

	// Query for video interfaces
	CComQIPtr<IVideoWindow> pVW(m_pGB) ;
	if (pVW != NULL)
	{
		LIF(pVW->put_Owner((OAHWND)m_hWnd)) ;
		LIF(pVW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN)) ;

		// resizing
		LIF(OnSize());
	}

	// Get the video size
    /*
	CComQIPtr<IBasicVideo> pBV(m_pGB) ;
	if (pBV != NULL)
	{
		long lWidth, lHeight ;
		hr = pBV->GetVideoSize(&lWidth, &lHeight) ;
		if (SUCCEEDED(hr))
		{
			// Track the movement of the container window and resize as needed
			//RECT rcToolbar ;
			//GetWindowRect(m_hwndToolBar, &rcToolbar) ;
			//int nToolbarHeight = rcToolbar.bottom - rcToolbar.top ;

			SetWindowPos(m_hWnd, HWND_NOTOPMOST, 0, 0,
				lWidth, lHeight,
				SWP_SHOWWINDOW|SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE) ;
		}
	}
    */

	// Set the owner window to receive event notices
	CComQIPtr<IMediaEventEx> pME(m_pGB) ;
	if (pME != NULL)
	{
		LIF(pME->SetNotifyWindow((OAHWND)m_hWnd, WM_GRAPHNOTIFY, 0)) ;
	}

#ifdef REGISTER_FILTERGRAPH
    hr = AddGraphToRot(m_pGB, &m_dwGraphRegister) ;
    if (FAILED(hr))
    {
        TRACE(TEXT("Failed to register filter graph with ROT!  hr=0x%x"), hr) ;
        m_dwGraphRegister = 0 ;
    }
#endif

	return S_OK ;
}

HRESULT CVideoChatApp::FindFirstDevice(REFCLSID clsidDeviceClass, IBaseFilter **ppSrcFilter)
{
	HRESULT hr;
	IBaseFilter *pSrc = NULL;
	CComPtr<IMoniker> pMoniker;
	ULONG cFetched;

	// Create the system device enumerator
	CComPtr <ICreateDevEnum> pDevEnum;

	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
		IID_ICreateDevEnum, (void ** ) &pDevEnum);
	if (FAILED(hr))
	{
		TRACE(TEXT("Couldn't create system enumerator!  hr=0x%x\n"), hr);
		return hr;
	}

	// Create an enumerator for the devices
	CComPtr<IEnumMoniker> pClassEnum;

	hr = pDevEnum->CreateClassEnumerator(clsidDeviceClass, &pClassEnum, 0);
	if (FAILED(hr))
	{
		TRACE(TEXT("Couldn't create class enumerator!  hr=0x%x\n"), hr);
		return hr;
	}

	// If there are no enumerators for the requested type, then 
	// CreateClassEnumerator will succeed, but pClassEnum will be NULL.
	if (pClassEnum == NULL)
	{
		TRACE(TEXT("No device was detected.\n"));
		return E_FAIL;
	}

	// Use the first device on the device list.
	// Note that if the Next() call succeeds but there are no monikers,
	// it will return S_FALSE (which is not a failure).  Therefore, we
	// check that the return code is S_OK instead of using SUCCEEDED() macro.
	if (S_OK == (pClassEnum->Next (1, &pMoniker, &cFetched)))
	{
		// Bind Moniker to a filter object
		hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&pSrc);
		if (FAILED(hr))
		{
			TRACE(TEXT("Couldn't bind moniker to filter object!  hr=0x%x\n"), hr);
			return hr;
		}
	}
	else
	{
		TRACE(TEXT("Unable to access device!\n"));
		return E_FAIL;
	}

	// Copy the found filter pointer to the output parameter.
	// Do NOT Release() the reference, since it will still be used
	// by the calling function.
	*ppSrcFilter = pSrc;

	return hr;
}

HRESULT CVideoChatApp::CleanDirectShow()
{
	// ͱ׷Ŵ   
	if (m_pGB == NULL)
		return E_ABORT ;

    HRESULT hr ;
 
	// Query for media control interfaces
	CComQIPtr<IMediaControl> pMC(m_pGB);
	if (pMC != NULL)
	{
		// Stop the graph to stop the media file
		LIF(pMC->Stop()) ;
	}
 
	// Query for media event interfaces
	CComQIPtr<IMediaEventEx> pME(m_pGB);
	if (pME != NULL)
	{
		// Relinquish ownership (IMPORTANT!)
		LIF(pME->SetNotifyWindow(NULL, WM_GRAPHNOTIFY, 0));
	}

	// Query for video interfaces
	CComQIPtr<IVideoWindow> pVW(m_pGB);
	if (pVW != NULL)
	{
		// Relinquish ownership (IMPORTANT!) after hiding video window
		LIF(pVW->put_Visible(OAFALSE));
		LIF(pVW->put_Owner(NULL));
	}

#ifdef REGISTER_FILTERGRAPH
    if (m_dwGraphRegister)
    {
        RemoveGraphFromRot(m_dwGraphRegister) ;
        m_dwGraphRegister = 0 ;
    }
#endif

	// ͱ׷Ŵ Ͽ ͱ׷  !
	// Release Filter Graph Manager
	SAFE_RELEASE(m_pGB) ;

    return S_OK ;
}

HRESULT CVideoChatApp::OnSize()
{
	if (m_pGB == NULL)
		return E_ABORT ;

	HRESULT hr;

	CComQIPtr<IVideoWindow> pVW(m_pGB);
	if (pVW != NULL)
	{
		// Track the movement of the container window and resize as needed
		//RECT rcToolbar;
		//GetWindowRect(m_hwndToolBar, &rcToolbar);
		//int nToolbarHeight = rcToolbar.bottom - rcToolbar.top;

        ((CVideoChatDlg*)m_pMainWnd)->m_ctrPreView.GetClientRect(&m_rect);
		((CVideoChatDlg*)m_pMainWnd)->ScreenToClient(&m_rect);
		
		//GetClientRect(m_hWnd, &rect);
		//LIF(pVW->SetWindowPosition(16, 20, 160+15, 120+19 ) );

		LIF(pVW->SetWindowPosition(m_rect.left+14, m_rect.top+56, m_rect.Width(), m_rect.Height()) );
	} 
	return hr;
}

int CVideoChatApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
    // ͱ׷Ŵ  
	if (m_pGB != NULL)
	{
		CleanDirectShow() ;
	}

    // Finished with COM
    CoUninitialize() ;

	return CWinApp::ExitInstance();
}

HRESULT CVideoChatApp::PlayPreview()
{
	HRESULT hr ;

	// ͱ׷Ŵ   
	if (m_pGB == NULL)
		JIF(InitDirectShow() ) ;

	// Let's get ready to rumble!
	ShowWindow(m_hWnd, SW_SHOW) ;
	UpdateWindow(m_hWnd) ;
	SetForegroundWindow(m_hWnd) ;
	SetFocus(m_hWnd) ;

	// Query for media control interfaces
	CComQIPtr<IMediaControl> pMC(m_pGB);
	if (pMC != NULL)
	{
		// Run the graph to play the media file
		LIF(pMC->Run()) ;
	}
	// give a focus to the Video window, again!
	SetFocus(m_hWnd) ;
  
	return hr ;
}

void CVideoChatApp::CaptureScreenToFile(CString csFileName)
{
	if (m_pSG == NULL)
		return;

	HRESULT hr;

	CComQIPtr<ISampleGrabber> pSampleGrabber(m_pSG);
	if (pSampleGrabber == NULL)
		return;

	long lBufferSize;

	hr = pSampleGrabber->GetCurrentBuffer(&lBufferSize, NULL);
	if (FAILED(hr))
		return;

	BYTE* pBuffer = new BYTE[lBufferSize];
	if (!pBuffer)
		return;

	hr = pSampleGrabber->GetCurrentBuffer(&lBufferSize, (long *)pBuffer);
	if (SUCCEEDED(hr))
	{
		AM_MEDIA_TYPE mt;
		pSampleGrabber->GetConnectedMediaType(&mt); 
		VIDEOINFOHEADER *pviHeader = (VIDEOINFOHEADER *)mt.pbFormat;

		//
	//	CIJL ijl;
	//	ijl.LoadFromDIBBuf(&pviHeader->bmiHeader, pBuffer);
	//	ijl.SaveToJpegFile(csFileName.GetBuffer(0));

		CIJL::SaveToJpegFileFromDIBBuf(csFileName.GetBuffer(0),&pviHeader->bmiHeader, pBuffer);
	}
	else
		MessageBox(m_hWnd, "Fail", "-_-", MB_OK);

	delete [] pBuffer;
}

void CVideoChatApp::CaptureScreenToBuffer(CIJL * pIJL)
{
	if (m_pSG == NULL)
		return;
	
	HRESULT hr;
	
	CComQIPtr<ISampleGrabber> pSampleGrabber(m_pSG);
	if (pSampleGrabber == NULL)
		return;
	
	long lBufferSize;
	
	hr = pSampleGrabber->GetCurrentBuffer(&lBufferSize, NULL);
	if (FAILED(hr))
		return;
	
	BYTE* pBuffer = new BYTE[lBufferSize];
	if (!pBuffer)
		return;
	
	hr = pSampleGrabber->GetCurrentBuffer(&lBufferSize, (long *)pBuffer);
	if (SUCCEEDED(hr))
	{
		AM_MEDIA_TYPE mt;
		pSampleGrabber->GetConnectedMediaType(&mt); 
		VIDEOINFOHEADER *pviHeader = (VIDEOINFOHEADER *)mt.pbFormat;
			
		pIJL->LoadFromDIBBuf(&pviHeader->bmiHeader, (BYTE*)pBuffer);	
		pIJL->DoFlip();
	}
	else
		MessageBox(m_hWnd,"Fail", "-_-", MB_OK);
	
	delete [] pBuffer;
}


