// VideoChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VideoChat.h"
#include "VideoChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CVideoChatDlg dialog

CVideoChatDlg::CVideoChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoChatDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVideoChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoChatDlg)
	DDX_Control(pDX, IDC_STATIC_FILEVIEW, m_ctrFileView);
	DDX_Control(pDX, IDC_STATIC_PREVIEW, m_ctrPreView);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVideoChatDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoChatDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_FILE, OnBtnFile)
	ON_BN_CLICKED(IDC_BTN_BUFFER, OnBtnBuffer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoChatDlg message handlers

BOOL CVideoChatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	lpJpeg = new CIJL;

	// TODO: Add extra initialization here
    ((CVideoChatApp*)AfxGetApp())->InitDirectShow();
   ((CVideoChatApp*)AfxGetApp())->PlayPreview();
	//if( SetTimer( 100, SNAPTIME, 0) == 0)
	//	AfxMessageBox("Error : Can not Create Timer");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVideoChatDlg::OnPaint() 
{	
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void CVideoChatDlg::DrawJpegFile(CString csFileName)
{    
	char szFileName[100];
	strcpy(szFileName,csFileName);
	lpJpeg->OpenJpegFile(szFileName);

	DrawJpegBuffer(lpJpeg);
}

void CVideoChatDlg::DrawJpegBuffer(CIJL * pIJL)
{	
    CClientDC dc(this);
    	
	CSize jpegsize;
	CRect rect;
	m_ctrFileView.GetClientRect(&rect);
	ScreenToClient(&rect);
	
	jpegsize.cx = rect.Width();
	jpegsize.cy = 144;
	
	pIJL->DrawJpeg(&dc, &CRect(11, 504, rect.Width()+11, -rect.Height() ),
		&CRect(0, 504, jpegsize.cx, -jpegsize.cy));
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVideoChatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVideoChatDlg::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class

	if(lpJpeg)
	{
		lpJpeg->DeleteBitInfo();
		delete lpJpeg;
	}	
	CDialog::PostNcDestroy();
}



void CVideoChatDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnClose();
}

void CVideoChatDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == TIMER_FILESAVE)
	{		
		// Ϸ ߴٰ
		g_GetApp()->CaptureScreenToFile(UNION_FILENAME);
		
		// Ϸ  ȭ鿡 ׸
		DrawJpegFile(UNION_FILENAME);
	}
	else if(nIDEvent == TIMER_BUFFERSAVE)
	{		
		// ۷ ؼ(DIB)
		CIJL ijl;
		g_GetApp()->CaptureScreenToBuffer(&ijl);
		 
		// ȭ鿡 ׸
		DrawJpegBuffer(&ijl);

		// Jpeg۸ ͼ Ʈ 
// 		int nSize = MAX_IMAGESIZE;
// 		PBYTE buff = new BYTE[nSize];
// 		nSize = m_pJpeg->SaveToJpegBuf(buff,nSize,90);
// 		if(m_bHalf)
// 		{
			//  
// 			m_pJpeg->DecodeOneHalfFromJpegBuf(buff,nSize);
// 			if(buff)
// 				delete [] buff;
// 			
// 			nSize = MAX_IMAGESIZE;
// 			buff = new BYTE[nSize];
// 			nSize = m_pJpeg->SaveToJpegBuf(buff,nSize,90);				
// 		}
// 		if(m_pClientSock)
// 			SendData(buff,nSize);
// 		if(buff)
// 				delete [] buff;
	}

	CDialog::OnTimer(nIDEvent);
}

void CVideoChatDlg::OnBtnFile() 
{
	KillTimer(TIMER_FILESAVE);
	KillTimer(TIMER_BUFFERSAVE);

	SetTimer(TIMER_FILESAVE, SNAPTIME, NULL);
}

void CVideoChatDlg::OnBtnBuffer() 
{
	KillTimer(TIMER_FILESAVE);
	KillTimer(TIMER_BUFFERSAVE);

	SetTimer(TIMER_BUFFERSAVE, SNAPTIME, NULL);
}
