// CIJL.cpp: implementation of the CIJL class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ijl.h"
#include "CIJL.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CIJL::CIJL()
{
	m_lpHeader = NULL;
	m_lpData = NULL;
}

CIJL::~CIJL()
{
	DeleteBitInfo();
}

// CJpegInfo .
void CIJL::DeleteBitInfo()
{
	if (m_lpData) 
		delete [] m_lpData;
	m_lpData = NULL;
	if (m_lpHeader)
		delete m_lpHeader;
	m_lpHeader = NULL;
}

// Jpg۸ CJpegInfo 
bool CIJL::LoadFromDIBBuf(BITMAPINFOHEADER * bmiHeader, BYTE *pDIB)
{
	if(bmiHeader->biBitCount  !=  24)
		return false;

	DeleteBitInfo();
	
	int nWidth = bmiHeader->biWidth;
	int nHeight = bmiHeader->biHeight;
	int nBufSize = bmiHeader->biSizeImage;
	los = 3 * (nWidth + 1) & (~3);
	m_lpHeader = new BITMAPINFOHEADER;
	if (m_lpHeader) 
		memcpy(m_lpHeader, bmiHeader, sizeof(BITMAPINFOHEADER));
	m_lpData = new BYTE [nBufSize];	// ̹  ŭ ޸𸮿 Ҵ
	if (m_lpData) 
		memcpy(m_lpData, pDIB, nBufSize);
	return true;
}

// Jpg۸ CJpegInfo 
bool CIJL::LoadFromJpegBuf(BYTE* lpJpgBuffer,int nBufSize)
{
	DeleteBitInfo();

	bool      bres;
	IJLERR  jerr;
	DWORD    dwWholeImageSize;
	BYTE*    lpTemp  =  NULL;
	//  Allocate  the  IJL  JPEG_CORE_PROPERTIES  structure.
	JPEG_CORE_PROPERTIES  jcprops;
	bres  =  TRUE;
	__try
	{
		//  Initialize  the  Intel(R)  JPEG  Library.
		jerr  =  ijlInit(&jcprops);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}
		//  Get  information  on  the  JPEG  image
		//  (i.e.,  width,  height,  and  channels).
		jcprops.JPGFile =  NULL;
		jcprops.JPGBytes =  lpJpgBuffer;
		jcprops.JPGSizeBytes  =  nBufSize;
		jerr  =  ijlRead(&jcprops,  IJL_JBUFF_READPARAMS);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}
		//  Set  the  JPG  color  space  ...  this  will  always  be
		//  somewhat  of  an  educated  guess  at  best  because  JPEG
		//  is  "color  blind"  (i.e.,  nothing  in  the  bit  stream
		//  tells  you  what  color  space  the  data  was  encoded  from).
		//  However,  in  this  example  we  assume  that  we  are
		//  reading  JFIF  files  which  means  that  3  channel  images
		//  are  in  the  YCbCr  color  space  and  1  channel  images  are
		//  in  the  Y  color  space.
		switch(jcprops.JPGChannels)
		{
		case  1:
			{
				jcprops.JPGColor        =  IJL_G;
				//jcprops.DIBColor        =  IJL_RGB;
				jcprops.DIBColor        =  IJL_BGR;
				jcprops.DIBChannels  =  3;
				break;
			}
		case  3:
			{
				jcprops.JPGColor        =  IJL_YCBCR;
				//jcprops.DIBColor        =  IJL_RGB;
				jcprops.DIBColor        =  IJL_BGR;
				jcprops.DIBChannels  =  3;
				break;
			}
		default:
			{
				//  This  catches  everything  else,  but  no
				//  color  twist  will  be  performed  by  the  IJL.
				jcprops.JPGColor        =  (IJL_COLOR)IJL_OTHER;
				jcprops.DIBColor        =  (IJL_COLOR)IJL_OTHER;
				jcprops.DIBChannels  =  jcprops.JPGChannels;
				break;
			}
		}
		//  Compute  size  of  desired  pixel  buffer.
		dwWholeImageSize  =  jcprops.JPGWidth  *  jcprops.JPGHeight  *
			jcprops.DIBChannels;
		//  Allocate  memory  to  hold  the  decompressed  image  data.
		lpTemp  =  new  BYTE  [dwWholeImageSize];
		if(NULL  ==  lpTemp)
		{
			bres  =  FALSE;
			__leave;
		}
		//  Set  up  the  info  on  the  desired  DIB  properties.
		jcprops.DIBWidth        =  jcprops.JPGWidth;
		jcprops.DIBHeight      =  jcprops.JPGHeight;
		jcprops.DIBPadBytes  =  0;
		jcprops.DIBBytes        =  lpTemp;
		//  Now  get  the  actual  JPEG  image  data  into  the  pixel  buffer.
		jerr  =  ijlRead(&jcprops,  IJL_JBUFF_READWHOLEIMAGE);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}

		// CIJL 
		INT width = jcprops.DIBWidth;
		INT height = jcprops.DIBHeight;
		los = 3 * (width + 1) & (~3);

		m_lpData = new BYTE [dwWholeImageSize];	// ̹  ŭ ޸𸮿 Ҵ
		memcpy(m_lpData, jcprops.DIBBytes, dwWholeImageSize);

		m_lpHeader = new BITMAPINFOHEADER;
		ZeroMemory(m_lpHeader, sizeof(LPBITMAPINFOHEADER));
		m_lpHeader->biSize = sizeof(BITMAPINFOHEADER);
		m_lpHeader->biPlanes = 1;
		m_lpHeader->biCompression = BI_RGB;
		m_lpHeader->biBitCount = 24;
		m_lpHeader->biWidth = width;
		m_lpHeader->biHeight = height;
	}  //  __try
	__finally
	{
		//if(FALSE  ==  bres)
		{
			if(NULL  !=  lpTemp)
			{
				delete  []  lpTemp;
				lpTemp  =  NULL;
			}
		}
		//  Clean  up  the  Intel(R)  JPEG  Library.
		ijlFree(&jcprops);
	}  //  __finally
	return  bres;
}

// Jpg  CJpegInfo ҷ.
// DecodeJPGFileToDIB
bool CIJL::LoadJpegFile(LPSTR lpszFileName)
{
    DeleteBitInfo();

	bool      bres = true;
	IJLERR  jerr;
	DWORD    width;
	DWORD    height;
	DWORD    nchannels;
	DWORD    dib_line_width;
	DWORD    dib_pad_bytes;
	DWORD    wholeimagesize;
	BYTE* buffer  =  NULL;
	BITMAPINFOHEADER*  bmih      =  NULL;
	//  Allocate  the  IJL  JPEG_CORE_PROPERTIES  structure.
	JPEG_CORE_PROPERTIES  jcprops;
	  
	__try
	{
		//  Initialize  the  IntelR  JPEG  Library.
		jerr  =  ijlInit(&jcprops);
		if(IJL_OK  !=  jerr)
		{
			bres  =  false;
			__leave;
		}
		//  Get  information  on  the  JPEG  image
		//  (i.e.,  width,  height,  and  channels).
		jcprops.JPGFile  =  const_cast<LPSTR>(lpszFileName);
		jerr  =  ijlRead(&jcprops,IJL_JFILE_READPARAMS);
		if(IJL_OK  !=  jerr)
		{
			bres  =  false;
			__leave;
		}
		//  Set  up  local  data.
		width =  jcprops.JPGWidth;
		height        =  jcprops.JPGHeight;
		nchannels  =  3;  //  Decode  into  a  3  channel  pixel  buffer.
		//  Compute  DIB  padding
		dib_line_width  =  width  *  nchannels;
		dib_pad_bytes    =  IJL_DIB_PAD_BYTES(width,nchannels);
		//  Compute  size  of  desired  pixel  buffer.
		wholeimagesize  =  (  dib_line_width  +  dib_pad_bytes  )  *  height;
		//  Allocate  memory  to  hold  the  decompressed  image  data.
		buffer  =  new  BYTE  [sizeof(BITMAPINFOHEADER)  +  wholeimagesize];
		if(NULL  ==  buffer)
		{
			bres  =  false;
			__leave;
		}
		bmih  =  reinterpret_cast<BITMAPINFOHEADER*>(buffer);
		bmih->biSize =  sizeof(BITMAPINFOHEADER);
		bmih->biWidth =  width;
		bmih->biHeight =  height;
		bmih->biPlanes =  1;
		bmih->biBitCount =  24;
		bmih->biCompression      =  BI_RGB;
		bmih->biSizeImage =  0;
		bmih->biXPelsPerMeter  =  0;
		bmih->biYPelsPerMeter  =  0;
		bmih->biClrUsed =  0;
		bmih->biClrImportant    =  0;
		//  Set  up  the  info  on  the  desired  DIB  properties.
		jcprops.DIBWidth        =  width;
		jcprops.DIBHeight      =  height;  //  Implies  a  bottom-up  DIB.
		jcprops.DIBChannels  =  nchannels;
		jcprops.DIBColor        =  IJL_BGR;
		jcprops.DIBPadBytes  =  dib_pad_bytes;
		jcprops.DIBBytes        =  reinterpret_cast<BYTE*>(buffer  +
			sizeof(BITMAPINFOHEADER));
		//  Set  the  JPG  color  space  ...  this  will  always  be
		//  somewhat  of  an  educated  guess  at  best  because  JPEG
		//  is  "color  blind"  (i.e.,  nothing  in  the  bit  stream
		//  tells  you  what  color  space  the  data  was  encoded  from).
		//  However,  in  this  example  we  assume  that  we  are
		//  reading  JFIF  files  which  means  that  3  channel  images
		//  are  in  the  YCbCr  color  space  and  1  channel  images  are
		//  in  the  Y  color  space.
		switch(jcprops.JPGChannels)
		{
		case  1:
			{
				jcprops.JPGColor  =  IJL_G;
				break;
			}
		case  3:
			{
				jcprops.JPGColor  =  IJL_YCBCR;
				break;
			}
		default:
			{
				//  This  catches  everything  else,  but  no
				//  color  twist  will  be  performed  by  the  IJL.
				jcprops.DIBColor  =  (IJL_COLOR)IJL_OTHER;
				jcprops.JPGColor  =  (IJL_COLOR)IJL_OTHER;
				break;
			}
		}
		//  Now  get  the  actual  JPEG  image  data  into  the  pixel  buffer.
		jerr  =  ijlRead(&jcprops,IJL_JFILE_READWHOLEIMAGE);
		if(IJL_OK  !=  jerr)
		{
			bres  =  false;
			__leave;
		}
		
		// CIJL 
		INT width = jcprops.DIBWidth;
		INT height = jcprops.DIBHeight;
		los = 3 * (width + 1) & (~3);
		
		m_lpHeader = new BITMAPINFOHEADER;
		memcpy(m_lpHeader, bmih, sizeof(BITMAPINFOHEADER));
		m_lpData = new BYTE [wholeimagesize];	// ̹  ŭ ޸𸮿 Ҵ
		memcpy(m_lpData, jcprops.DIBBytes, wholeimagesize);

	}  //  __try
	__finally
	{
	//	if(false  ==  bres)
		{
			if(NULL  !=  buffer)	// ۸  Ƿ  
			{
				delete  []  buffer;
				buffer  =  NULL;
			}
		}
		//  Clean  up  the  IntelR  JPEG  Library.
		ijlFree(&jcprops);
	}  //  __finally
	return  bres;
}

// loadJpeg ! jpg ҷ
bool CIJL::OpenJpegFile(LPSTR lpszFileName)
{
	bool bTrue;
	CFileFind ff;

	if (ff.FindFile(lpszFileName, NULL))
		bTrue = true;
	else
		bTrue = false;

	ff.Close();

	if (bTrue)
		LoadJpegFile(lpszFileName);

	return bTrue;
}

// JpgϷ 
bool CIJL::SaveToJpegFile(CString csFileName)
{
	if(!IsValid())
		return false;

	return SaveToJpegFileFromDIBBuf(csFileName.GetBuffer(0),m_lpHeader,m_lpData);
}

// DIB۸ JpgϷ 
// EncodeJPGFileFromDIB
bool CIJL::SaveToJpegFileFromDIBBuf(LPSTR strFileName,BITMAPINFOHEADER * bmih, BYTE *pDIB)
{	
	if(bmih == NULL)
		return false;
	if(pDIB == NULL)
		return false;

	bool bres  =  true;
	IJLERR  jerr;
	DWORD    dib_pad_bytes;

	JPEG_CORE_PROPERTIES  jcprops;	//  JPEG ̺귯 Ƽ
	ZeroMemory(&jcprops, sizeof(jcprops));
	
	__try
	{
		//  Initialize  the  IntelR  JPEG  Library.
		jerr  =  ijlInit(&jcprops);
		if(IJL_OK  !=  jerr)
		{
			bres  =  false;
			__leave;
		}
		if(bmih->biBitCount  !=  24)
		{
			//  not  supported  palette  images
			bres  =  false;
			__leave;
		}

		dib_pad_bytes    =  IJL_DIB_PAD_BYTES(bmih->biWidth,3);
		//  Set  up  information  to  write  from  the  pixel  buffer.
		jcprops.DIBWidth        =  bmih->biWidth;
//		jcprops.DIBHeight      =   bmih->biHeight;  //  Implies  a  bottom-up  DIB.
		jcprops.DIBHeight      =  -bmih->biHeight;  
// 		jcprops.DIBBytes        =  reinterpret_cast<BYTE*>(bmih)  +
// 			sizeof(BITMAPINFOHEADER);
		jcprops.DIBBytes = (BYTE*)pDIB;
		jcprops.DIBPadBytes  =  dib_pad_bytes;
		//  Note:  the  following  are  default  values  and  thus
		//  do  not  need  to  be  set.
		jcprops.DIBChannels  =  3;
		jcprops.DIBColor        =  IJL_BGR;
		jcprops.JPGFile  =  const_cast<LPSTR>(strFileName);
		//  Specify  JPEG  file  creation  parameters.
		jcprops.JPGWidth    =  bmih->biWidth;
		jcprops.JPGHeight  =  bmih->biHeight;
		//  Note:  the  following  are  default  values  and  thus
		//  do  not  need  to  be  set.
		jcprops.JPGChannels        =  3;
		jcprops.JPGColor =  IJL_YCBCR;
		jcprops.JPGSubsampling  =  IJL_411;  //  4:1:1  subsampling.
		jcprops.jquality =  75; //  Select  "good"  image  quality
				
		//  Write  the  actual  JPEG  image  from  the  pixel  buffer.
		jerr  =  ijlWrite(&jcprops,IJL_JFILE_WRITEWHOLEIMAGE);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}
	}  //  __try
	__finally
	{
		//  Clean  up  the  IntelR  JPEG  Library.
		ijlFree(&jcprops);
	}
	return bres;
}

// CJpegInfo ̹ ۸ .
//  EncodeToJPEGBuffer 
int CIJL::SaveToJpegBuf(BYTE* &lpJpgBuffer,int jquality)
{
	if(!IsValid())
		return 0;

	int nBufSize = 0;
	DWORD    dwWidth = m_lpHeader->biWidth;
	DWORD    dwHeight = abs(m_lpHeader->biHeight);
	
	bool      bres;
	IJLERR  jerr;
	DWORD    dwRgbBufferSize;
	BYTE*    lpTemp;
	//  Allocate  the  IJL  JPEG_CORE_PROPERTIES  structure.
	JPEG_CORE_PROPERTIES  jcprops;
	ZeroMemory(&jcprops, sizeof(jcprops));

	bres  =  TRUE;
	__try
	{
		//  Initialize  the  Intel(R)  JPEG  Library.Inside the Library
		
		jerr  =  ijlInit(&jcprops);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}

		dwRgbBufferSize  =  dwWidth  *  dwHeight  *  3;

		lpTemp  =  new  BYTE  [dwRgbBufferSize];
		if(NULL  ==  lpTemp)
		{
			bres  =  FALSE;
			__leave;
		}

		//  Set  up  information  to  write  from  the  pixel  buffer.
		jcprops.DIBWidth =  dwWidth;
		jcprops.DIBHeight =  dwHeight;  //  Implies  a  bottom-up  DIB.
		jcprops.DIBBytes =  m_lpData;
		jcprops.DIBPadBytes        =  0;
		jcprops.DIBChannels        =  3;
		jcprops.DIBColor =  IJL_BGR;//RGB;

		jcprops.JPGWidth =  dwWidth;
		jcprops.JPGHeight =  dwHeight;
		jcprops.JPGFile =  NULL;
		jcprops.JPGBytes =  lpTemp;
		jcprops.JPGSizeBytes      =  dwRgbBufferSize;
		jcprops.JPGChannels        =  3;
		jcprops.JPGColor =  IJL_YCBCR;
		jcprops.JPGSubsampling  =  IJL_411;  //  4:1:1  subsampling.
		jcprops.jquality =  jquality;  //  Select  "good"  image  quality

		//  Write  the  actual  JPEG  image  from  the  pixel  buffer.
		jerr  =  ijlWrite(&jcprops,IJL_JBUFF_WRITEWHOLEIMAGE);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}
	}  //  __try
	__finally
	{
		nBufSize  =  jcprops.JPGSizeBytes;
		memcpy(lpJpgBuffer,lpTemp,nBufSize);
				
		//  Clean  up  the  Intel(R)  JPEG  Library.
		ijlFree(&jcprops);

		if(NULL  !=  lpTemp)
		{
			delete[]  lpTemp;
			lpTemp  =  NULL;
		}
	}

	return nBufSize;
}

// Jpg۸  ٿ CJpegInfo 
// SDK DecodeJPGFileOneEighth 
bool  CIJL::DecodeOneHalfFromJpegBuf(BYTE* lpJpgBuffer,int nBufSize)
{
	DeleteBitInfo();

	bool      bres;
	IJLERR  jerr;
	DWORD    width;
	DWORD    height;
	DWORD    nchannels;
	DWORD    wholeimagesize;
	BYTE*    pixel_buf  =  NULL;
	//  Allocate  the  IJL  JPEG_CORE_PROPERTIES  structure.
	JPEG_CORE_PROPERTIES  jcprops;
	ZeroMemory(&jcprops, sizeof(jcprops));

	bres  =  TRUE;
	__try
	{
		//  Initialize  the  IntelR  JPEG  Library.
		jerr  =  ijlInit(&jcprops);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}
		jcprops.JPGFile      = NULL;
		jcprops.JPGBytes     = lpJpgBuffer;
		jcprops.JPGSizeBytes = nBufSize;

		//  Get  information  on  the  JPEG  image
		//  (i.e.,  width,  height,  and  channels).
		jerr  =  ijlRead(&jcprops,  IJL_JBUFF_READPARAMS);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}
		//  Set  up  local  data.
		//  Note:  In  this  case,  width  and  height  are  rounded
		//  to  the  nearest  factor  of  eight.
		width =  (jcprops.JPGWidth  )  /2;
		height        =  (jcprops.JPGHeight ) /2;
		nchannels  =  3;  //  Decode  into  a  3  channel  pixel  buffer.
		wholeimagesize  =  (width  *  height  *  nchannels);
		nBufSize = wholeimagesize;
		//  Allocate  memory  to  hold  the  decompressed  image  data.
		pixel_buf  =  new  BYTE  [wholeimagesize];
		if(NULL  ==  pixel_buf)
		{
			bres  =  FALSE;
			__leave;
		}
		//  Set  up  the  info  on  the  desired  DIB  properties.
		jcprops.DIBWidth        =  width;
		jcprops.DIBHeight      =  height;  //  Implies  a  bottom-up  DIB.
		jcprops.DIBChannels  =  nchannels;
		jcprops.DIBColor        =  IJL_BGR;
		jcprops.DIBPadBytes  =  0;
		jcprops.DIBBytes        =  pixel_buf;
		//  Set  the  JPG  color  space  ...  this  will  always  be
		//  somewhat  of  an  educated  guess  at  best  because  JPEG
		//  is  "color  blind"  (i.e.,  nothing  in  the  bit  stream
		//  tells  you  what  color  space  the  data  was  encoded  from).
		//  However,  in  this  example  we  assume  that  we  are
		//  reading  JFIF  files  which  means  that  3  channel  images
		//  are  in  the  YCbCr  color  space  and  1  channel  images  are
		//  in  the  Y  color  space.
		switch(jcprops.JPGChannels)
		{
		case  1:
			{
				jcprops.JPGColor  =  IJL_G;
				break;
			}
		case  3:
			{
				jcprops.JPGColor  =  IJL_YCBCR;
				break;
			}
		default:
			{
				//  This  catches  everything  else,  but  no
				//  color  twist  will  be  performed  by  the  IJL.
				jcprops.DIBColor  =  (IJL_COLOR)IJL_OTHER;
				jcprops.JPGColor  =  (IJL_COLOR)IJL_OTHER;
				break;
			}
		}
		//  Now  get  the  actual  JPEG  image  data  into  the  pixel  buffer
		//  and  scale  the  output  to  1/8  th  the  original  size.
		jerr  =  ijlRead(&jcprops,  IJL_JBUFF_READONEHALF);
		if(IJL_OK  !=  jerr)
		{
			bres  =  FALSE;
			__leave;
		}

		INT width = jcprops.DIBWidth;
		INT height = jcprops.DIBHeight;
		los = 3 * (width + 1) & (~3);

		m_lpHeader = new BITMAPINFOHEADER;
		m_lpData = new BYTE [nBufSize];	// ̹  ŭ ޸𸮿 Ҵ

		if (m_lpData)
			memcpy(m_lpData, jcprops.DIBBytes, nBufSize);
	}
	__finally
	{
		if(NULL  !=  pixel_buf)
		{
			delete  []  pixel_buf;
		}
		//  Clean  up  the  IntelR  JPEG  Library.
		ijlFree(&jcprops);
	}

	if (m_lpHeader)
	{
		ZeroMemory(m_lpHeader, sizeof(LPBITMAPINFOHEADER));
		m_lpHeader->biSize = sizeof(BITMAPINFOHEADER);
		m_lpHeader->biPlanes = 1;
		m_lpHeader->biCompression = BI_RGB;
		m_lpHeader->biBitCount = 24;
		m_lpHeader->biWidth = width;
		m_lpHeader->biHeight = height;
	}
	return  bres;
} 

//////////////////////////////////////////////////////////////////////////////////////////

// ȭ鿡 ׸
bool CIJL::DrawJpeg(CDC *pDC, CRect *pDest, CRect *pSrc)
{
	if(!IsValid())
		return false;
	if (!pDC) 
		return FALSE;
	if (!pDC->GetSafeHdc())
		return FALSE;
	
	StretchDIBits(pDC->GetSafeHdc(), pDest->left, pDest->bottom, pDest->Width(), -pDest->Height()-1 , 
		pSrc->left, pSrc->top, pSrc->Width(), pSrc->Height(),
		m_lpData, (LPBITMAPINFO)m_lpHeader, DIB_RGB_COLORS, SRCCOPY);

	return TRUE;
}

// ̹ 
bool CIJL::GetImageSize(CSize *pSize)
{
	if(!IsValid())
		return false;

	pSize->cx = m_lpHeader->biWidth;
	pSize->cy = m_lpHeader->biHeight;

	return TRUE;
}

void CIJL::DoFlip()
{
	if(!IsValid())
		return;

	int i;
	int nHeight;
	int nStride;
	BYTE *pSource, *pDestination;
	BYTE *pTempBuffer;
	
	nStride = m_lpHeader->biWidth * 3; //  ϴ Ʈ(RGB  )
	nHeight = m_lpHeader->biHeight;
	pSource = (BYTE*)m_lpData;
	pDestination = (BYTE*)m_lpData;
	pDestination += nStride * (nHeight - 1);
	pTempBuffer = (BYTE*)malloc(nStride);
	for (i = 0; i < nHeight / 2; i++)
	{
		memcpy(pTempBuffer, pDestination, nStride);
		memcpy(pDestination, pSource, nStride);
		memcpy(pSource, pTempBuffer, nStride);
		pSource += nStride;
		pDestination -= nStride;
	}
	free(pTempBuffer);
}

void CIJL::SetPixel(int x, int y, COLORREF col)
{
	if(!IsValid())
		return;

	if ((x * y) > (m_lpHeader->biHeight * m_lpHeader->biWidth))
		return;

	byte *pCol = m_lpData + y * los + (x << 1) + x;

	*(pCol + 2) = GetRValue(col);
	*(pCol + 1) = GetGValue(col);
	*pCol = GetBValue(col);
}

COLORREF CIJL::GetPixel(int x, int y)
{
	if(!IsValid())
		return 0;

	byte *col = m_lpData + y * los + (x << 1) + x;

	return (RGB(*(col + 2), *(col + 1), *col));
}

void CIJL::SetRect(CRect *pRect, COLORREF *ColData)
{
	if (pRect->right > m_lpHeader->biWidth)
		return;
	if (pRect->bottom > m_lpHeader->biHeight)
		return;
	if (pRect->left > pRect->right)
		return;
	if (pRect->bottom < pRect->top)
		return;

	int x, y, n = 0;
	for (y = pRect->top; y <= pRect->bottom; y ++)
	{
		for (x = pRect->left; x <= pRect->right; x ++)
		{
			SetPixel(x, y, *(ColData + n));
			n ++;
		}
	}
}

void CIJL::GetRect(CRect *pRect, COLORREF *ColData)
{
	if (pRect->right > m_lpHeader->biWidth) 
		return;
	if (pRect->bottom > m_lpHeader->biHeight) 
		return;
	if (pRect->left > pRect->right) 
		return;
	if (pRect->bottom < pRect->top) 
		return;

	int x, y, n = 0;

	for (y = pRect->top; y <= pRect->bottom; y ++)
	{
		for (x = pRect->left; x <= pRect->right; x ++)
		{
			*(ColData + n) = GetPixel(x, y);
			n ++;
		}
	}
}

void CIJL::SetFillRect(CRect *pRect, COLORREF col)
{
	if (pRect->right > m_lpHeader->biWidth) 
		return;
	if (pRect->bottom > m_lpHeader->biHeight) 
		return;
	if (pRect->left > pRect->right) 
		return;
	if (pRect->bottom < pRect->top)
		return;

	int x, y;
	for (y = pRect->top; y <= pRect->bottom; y ++)
	{
		for (x = pRect->left; x <= pRect->right; x ++)
		{
			SetPixel(x, y, col);
		}
	}
}
