// JpegViewView.cpp : implementation of the CJpegViewView class
//

#include "stdafx.h"
#include "JpegView.h"

#include "JpegViewDoc.h"
#include "JpegViewView.h"

#include "CIJL.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJpegViewView

IMPLEMENT_DYNCREATE(CJpegViewView, CView)

BEGIN_MESSAGE_MAP(CJpegViewView, CView)
	//{{AFX_MSG_MAP(CJpegViewView)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJpegViewView construction/destruction

CJpegViewView::CJpegViewView()
{
}

CJpegViewView::~CJpegViewView()
{
	m_Jpeg.DeleteBitInfo();
}

BOOL CJpegViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CJpegViewView drawing

void CJpegViewView::OnDraw(CDC* pDC)
{
	CJpegViewDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//////////////////////////////////////////////////////////
	CSize jpegsize;
	CRect rect;
	GetClientRect(&rect);
	CRect SrcRect;

	if(m_Jpeg.IsValid())
	{
		BOOL bFlag = m_Jpeg.GetImageSize(&jpegsize);
		if (bFlag)
		{
			pDC->FillSolidRect(jpegsize.cx, 0, rect.right, rect.bottom, 0x00ffffff);
			pDC->FillSolidRect(0, jpegsize.cy, rect.right, rect.bottom, 0x00ffffff);
		}
		else
			pDC->FillSolidRect(0, 0, rect.right, rect.bottom, 0x00ffffff);
		
		if (!m_Jpeg.DrawJpeg(pDC, &CRect(0, 0, jpegsize.cx, jpegsize.cy),
			&CRect(0, 0, jpegsize.cx, jpegsize.cy)))
			pDC->FillSolidRect(0, 0, 500, 500, 0x00ffffff);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CJpegViewView diagnostics

#ifdef _DEBUG
void CJpegViewView::AssertValid() const
{
	CView::AssertValid();
}

void CJpegViewView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CJpegViewDoc* CJpegViewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CJpegViewDoc)));
	return (CJpegViewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJpegViewView message handlers

void CJpegViewView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	GetDocument()->SetViewPtr((CWnd *)this);

	LoadJpeg();
}

void CJpegViewView::LoadJpeg()
{
	CJpegViewDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	char m_szFile[200] = "test.jpg";

	m_Jpeg.OpenJpegFile(m_szFile); //pDoc->m_szFileName
}

BOOL CJpegViewView::OnEraseBkgnd(CDC* pDC) 
{
	/*
	CSize jpegsize;
	CRect rect;
	GetClientRect(&rect);
	CJpegInfo *pInfo = (CJpegInfo *)lpJpeg;
	CRect SrcRect;

	BOOL bFlag = pInfo->GetImageSize(&jpegsize);
	if (bFlag)
	{
		pDC->FillSolidRect(jpegsize.cx, 0, rect.right, rect.bottom, 0x00ffffff);
		pDC->FillSolidRect(0, jpegsize.cy, rect.right, rect.bottom, 0x00ffffff);
	}
	else
		pDC->FillSolidRect(0, 0, rect.right, rect.bottom, 0x00ffffff);

	if (!pInfo->DrawJpeg(pDC, &CRect(0, 0, jpegsize.cx, jpegsize.cy),
		&CRect(0, 0, jpegsize.cx, jpegsize.cy)))
		pDC->FillSolidRect(0, 0, 500, 500, 0x00ffffff);
		*/

	return TRUE;
}